C
C     Copyright (c) 1986, 1988 Masatake Mori, All rights Reserved
C     This routine is appeared in
C     "FORTRAN 77 Suuchi Keisan Programing (in Japanese)"
C     Pubulished by Iwanami Shoten, 1986
C
c     $Id: dehint.f,v 1.1.1.1 2000/01/06 05:47:16 nakano Exp $
c
c     contains
c       subroutine hiab
c       subroutine dehint ( func, a, eps, v)
c

      subroutine hiab
c
c     initialization routine for dehint
c
      real*8 one
      real*8 h, eh, en, eni
      real*8 sh, ch
      real*8 am, a0, ap, bm, b0, bp

      common / comdef / am(640),a0,ap(640),
     $                  bm(640),b0,bp(640)
      common / comden / npow,nend

      parameter(one = 1)
      parameter(n6 = 6)

      npow = n6
      nend = 5 * 2**(npow+1)
      h = one / 2**(npow+1)
      eh = exp(h)


*     ---- case l = 3 ----

      a0 = 1.0d0
      b0 = 2.0d0
      en = 1.0d0

      do 30 i = 1, nend
        en = en * eh
        eni = 1 / en
        sh = en - eni
        ch = en + eni
        ap(i) = exp(sh)
        bp(i) = ch * ap(i)
        am(i) = 1 / ap(i)
        bm(i) = ch * am(i)
   30 continue

      return
      end


      subroutine dehint ( func, a, eps, v)
c
c     DE integration of function func for [a..eps)
c
c     eps is critical error, v is the result
c
      real*8 func,a,eps,v
      real*8 one,half
      real*8 h
      real*8 vold,vnew,wm,wp
      real*8 eps0,epsq,epsm,epsp,epsv
      real*8 am,a0,ap,bm,b0,bp

      common / comdef / am(640),a0,ap(640),
     $                  bm(640),b0,bp(640)
      common / comden / npow,nend
      common / comcnt / neval

      parameter (one = 1)
      parameter (half = one / 2)

      data eps0 / 1.0d-32 /
      data epsm / 0 /, epsp / 0 /

      neval = 0

      if (abs(eps) .ge. eps0) then
        epsv = abs(eps)
      else
        epsv = eps0
      end if

      epsq = 0.2d0 * dsqrt(epsv)

      h = half

      is = 2**npow
      ih = is

  101 continue

      km = 0
      kp = 0
      nm = 0
      np = 0

      vnew = 0

*     initial step h = 0.5 and check decay

      do 110 i = is, nend, ih

        if (kp .le. 1) then
          wp = func(ap(i) +a) *bp(i)
          neval = neval +1
          vnew = vnew +wp
          if (abs(wp) .le. epsv) then
            kp = kp + 1
            if (kp .ge. 2) then
              np = i - ih
              go to 111
            end if
          else
            kp = 0
          end if
        end if
  110 continue
  111 continue

      do 120 i = is, nend, ih

        if (km .le. 1) then
          wm = func(am(i) + a) * bm(i)
          neval = neval + 1
          vnew = vnew + wm

          if (abs(wm) .le. epsv) then
            km = km + 1
            if (km .ge. 2) then
              nm = i - ih
              go to 121
            end if
          else
            km = 0
          end if
        end if

  120 continue
  121 continue

      vnew = vnew + func(a0 + a) * b0
      neval = neval +1

      if (nm .eq. 0) then
        nm = nend
        epsm = 0.2d0 * dsqrt(abs(wm))
        write (*,2001)
 2001   format (' (dehint) slow decay on negative side')
      end if

      if (np .eq. 0) then
        np = nend
        epsp = 0.2d0 * dsqrt(abs(wp))
        write (*,2002)
 2002   format (' (dehint) slow decay in positive side')
      end if

      epsq = max(epsq, epsm, epsp)

*     general step

      vold = h * vnew

      do 20 mstep = 1, npow

        vnew = 0.0d0

        ih = is
        is = is / 2

        do 540 i = is, nm, ih
          vnew = vnew + func(am(i) + a) * bm(i)
          neval = neval + 1
  540   continue

        do 550 i = is, np, ih
          vnew = vnew + func(ap(i) + a) * bp(i)
          neval = neval + 1
  550   continue

        vnew = (vold + h * vnew) * half

        if (abs(vnew - vold) .lt. epsq) then

*       converged & return

          v = vnew
          return
        end if

        h = h * half
        vold = vnew

   20 continue

      write (*,2003)
 2003 format(' (dehint) insufficient mesh',' refinment')

      v = vnew
      return

      end
