#!/usr/bin/perl

@pg = (1.0, 2.0, 5.0, 10.0);
@r = (0.0, 2.0, 4.0, 0.0, 2.0, 4.0, 0.0, 2.0, 4.0);
@z = (1.0, 1.0, 1.0, 2.5, 2.5, 2.5, 4.0, 4.0, 4.0);
$nt = 10;

for ($ie = 0; $ie < @r; $ie++){

    my $dir = "src-$ie";
    system "mkdir -p $dir";

    for ($ip = 0; $ip < @pg; $ip++){
        for($it = 0; $it < $nt; $it++){
            
            my $infile = sprintf "%02d-%1d.in", $pg[$ip], $it;
	    $seed = 10000 * $ie + 100 * $ip + $it;

            dataout("$dir/$infile", $seed, $pg[$ip], $r[$ie], $z[$ie]);
	}
    }
}

sub dataout{
    my $outf = $_[0];
    my $seed = $_[1];
    my $pgas = $_[2];
    my $rej  = $_[3];
    my $zej  = $_[4];

    open IF, "> $outf";

#         1           # random seed      (10 digits max)
    printf IF "%10d\n", $seed;

    print IF << 'EOF';
     10000           # trial number     (10 digits max)
Cu                   # Sputtered atom: element name
     63.546          #                 mass (in atomic unit)
    13919.0          #    BM parameter A (eV)
      3.56137        #                 b (1/A)
Ar                   # Gas atom      : element name
     39.948          #                 mass (in atomic unit)
   6960.9            #    BM parameter A (eV)
      3.62645        #                 b (1/A)
    400.0            # Gas temperature (K)
EOF

#      1.0            # Gas pressure (ion gauge value) (Pa)
    printf IF "%14.6f\n", $pgas;

    print IF << 'EOF';
    296.0            #    Ion gauge's temperature assumption (K)
      0.6e-9         # Size of the collision target (m)
        30           # Spline func. for sca : node # of energy axis
        30           #                      :           col.param axis
      1.0e+3         #                      : max energy (eV)
      1.0e-4         #                      : min energy (eV)
      6.5            #                      : max col.param (A)
        30           # Spline func. for col : node # of energy axis
        30           #                      :           probability axis
      1.0e+3         #                      : max energy (eV)
      1.0e-4         #                      : min energy (eV)
      0.99           #                      : max probability
      0.01           #                      : min probability
   45                # node
      0.0            0.0
      0.5            0.0
      1.0            0.0
      1.5            0.0
      2.0            0.0
      2.5            0.0
      3.0            0.0
      3.5            0.0
      4.0            0.0
      4.5            0.0
      4.5           -1.0
      4.5           -2.0
      6.0           -2.0
      6.0           -4.5
     10.0           -4.5
     10.0           -2.0
     10.0            0.0
     10.0            2.0
     10.0            4.0
     10.0            6.0
     10.0            8.0
     10.0           10.0
     10.0           12.0
      6.0           12.0
      4.0           12.0
      2.0           12.0
      1.0           12.0
      1.0           10.0
      1.0            8.0
      1.0            6.5
      2.0            6.5
      2.5            6.5
      3.0            6.5
      3.5            6.5
      4.0            6.5
      4.0            6.0
      4.0            5.5
      4.0            5.0
      3.5            5.0
      3.0            5.0
      2.5            5.0
      2.0            5.0
      1.5            5.0
      1.0            5.0
      0.5            5.0
      0.0            5.0
EOF

#      4.0            2.5             #SOURCE

    printf IF "%14.6f%14.6f\n", $rej, $zej;
    close IF;
}
