#!/usr/bin/perl
use Statistics::Descriptive;

@pg = (1.0, 2.0, 5.0, 10.0);
@r = (0.0, 2.0, 4.0, 0.0, 2.0, 4.0, 0.0, 2.0, 4.0);
@z = (1.0, 1.0, 1.0, 2.5, 2.5, 2.5, 4.0, 4.0, 4.0);
$nt = 10;
$nnode = 45;

for ($ie = 0; $ie < @r; $ie++){

    my $dir = "src-$ie";
    system "mkdir -p $dir";

    for ($ip = 0; $ip < @pg; $ip++){
        $pf = sprintf "%02d", $pg[$ip];

        for($in = 1; $in <= $nnode; $in++){
	    $f[$ip][$in] = Statistics::Descriptive::Sparse->new();
	}

        for($it = 0; $it < $nt; $it++){
	    my $dfile = "$dir/$pf-$it.dat";
            if (! -f "$dfile") {die "$dfile does not exist"}
	    open DF, "$dfile";
	    while(<DF>){
		if (/^#/) {next;}
		chomp;
		@l = split;
		$f[$ip][$l[0]]->add_data($l[1]);
	    }
	    close DF;
	}
    }

    open OF, "> $dir.dat";
    print OF "# node\t1Pa (pm)\t2Pa (pm)\t5Pa (pm)\t10Pa (pm)\n";
    for($in = 1; $in <= $nnode; $in++){
	print OF "$in";
	for($ip = 0; $ip < @pg; $ip++){
	    my $count = $f[$ip][$in]->mean();
	    my $mean  = $f[$ip][$in]->mean();
	    my $sdev  = $f[$ip][$in]->standard_deviation();
	    my $mdev  = $sdev / sqrt($count);
	    print OF "\t$mean\t$mdev";
	}
	print OF "\n";
    }
    close OF;
}

