      program scollision
c
c     $Id: scolgas.F,v 1.3 2001/01/17 02:26:14 nakano Exp $
c     test routine for colgas.f
c     print nodes for spline func, then random trials
c
#include "hisput.h"
      real*8 unitam, unitbz
      parameter (unitam = UNITAM)
      parameter (unitbz = UNITBZ)

      real*8 tgas, pgasig, tgasig, ngas
      real*8 mgas, mpar, rmax
      integer ne, nw
      real*8 emax, emin, wmax, wmin
      real*8 vg, fp
      real*8 ep, wp

      integer*4 srand
      real*8 genrand

      integer it, nt1, nt2
      parameter (nt1=100, nt2=100)

      tgas = 400.0d0
      pgasig = 1.0d0
      tgasig = 296.0d0

      ngas = pgasig / (unitbz * tgasig)
C
C     Cu -> Ar
C
      mgas = 39.95d0 * unitam
      mpar = 63.5d0 * unitam
      rmax = 0.6d-9

      ne = 30
      nw = 30
      emax = 1.d3
      emin = 1.d-3
      wmax = 0.99d0
      wmin = 0.01d0

      call inispf1
      call inispf2

      srand = 1
      call sgenrand(srand)

      call setcol(tgas, ngas, mgas, mpar, rmax,
     $     ne, nw, emax, emin, wmax, wmin)

      write(6,1000)
 1000 format ('# RANDOM TEST (1): Ep(eV), Wp & Free path (m)')
      do 10 it = 1, nt1
         ep = 10.0d0 ** (-3.0d0 + 6.0d0 * genrand())
         wp = genrand()
         call frpath(ep, wp, fp)
         write(6,1010) ep, wp, fp
 1010    format(e20.7, f20.7, e20.7)
 10   continue

      write(6,1100)
 1100 format (/, '# RANDOM TEST (2): Ep(eV), Wp & Vgas (m/s)')
      do 20 it = 1, nt2
         ep = 10.0d0 ** (-3.0d0 + 6.0d0 * genrand())
         wp = genrand()
         call colgas(ep, wp, vg)
         write(6,1010) ep, wp, vg
 20   continue

      stop
      end

