      program sinc
C
C     $Id: sinc.f,v 1.2 2000/06/26 11:32:05 nakano Exp $
C     test program for inc.f
C     particle trapping test for some paths
C     with a box boundary in r-z cood.
C
      real*8 mp, ep
      parameter (mp = 1.0d-3)
      parameter (ep = 3.12075324d15)

C
C     test region
C     
      integer ibc(4)
      data (ibc(i),i=1,4)/0,0,1,1/
      real r(2,4)
      data ((r(i,j),i=1,2),j=1,4)/
     $ 1.0, 0.0,
     $ 2.0, 0.0,
     $ 2.0, 1.0,
     $ 1.0, 1.0/

C
C     test paths
C
      integer ntpath
      parameter (ntpath = 17)
      real*8 tpath(3, 2, ntpath)
      data (((tpath(i,j,k),i=1,3),j=1,2),k=1,ntpath)/
     $  -3.0, 0.0,-0.1,   3.0, 0.0,-0.1,
     $  -3.0, 0.0, 0.0,   3.0, 0.0, 0.0,
     $  -3.0, 0.0, 0.5,   3.0, 0.0, 0.5,
     $  -3.0, 0.0, 1.0,   3.0, 0.0, 1.0,
     $  -3.0, 0.0, 1.1,   3.0, 0.0, 1.1,
     $  -3.0, 1.0, 0.5,   3.0, 1.0, 0.5,
     $  -3.0, 1.5, 0.5,   3.0, 1.5, 0.5,
     $  -2.0, 1.5, 0.5,   2.0, 1.5, 0.5, 
     $   0.0, 1.0,-0.1,   0.0, 1.0, 1.1,
     $   0.0, 1.5,-0.1,   0.0, 1.5, 1.1,
     $   0.0, 2.0,-0.1,   0.0, 2.0, 1.1,
     $   0.0, 0.0,-1.0,   0.0, 1.5, 0.5,
     $   1.5, 0.0, 0.3,   2.5, 0.0, 0.3,
     $   2.0, 0.0, 0.5,   2.0, 0.0, 0.8,
     $   1.5,-3.0, 0.0,   1.5, 3.0, 0.0,
     $   1.5, 2.0, 0.0,   1.5, 0.0, 0.0,
     $   1.5, 0.0, 0.0,   1.5, 2.0, 0.0/

c
c     for vp = 1.0 m/s
c
      real*8 p1(3), p2(3)

      open(unit=10, file="region.dat")
 2000 format(i10)
 2010 format(2f14.6, i2)

      write(10,2000) 1
      write(10,2000) 1
      do 10 j = 1, 4
         write(10,2010) (r(i,j),i=1,2), ibc(j)
 10   continue
      close(10)

      call setinc(mp)

 1000 format(1x, 'Test', I2, ':')
 1010 format(1x, '  path (', 3f7.3, ')-(', 3f7.3, ')')
      do 20 itpath = 1, ntpath
         write(6,1000) itpath
         write(6,1010) (tpath(j,1,itpath),j=1,3),
     $        (tpath(j,2,itpath),j=1,3)
         do 22 j = 1, 3
            p1(j) = tpath(j, 1, itpath) * 1.0d-2
            p2(j) = tpath(j, 2, itpath) * 1.0d-2
 22      continue
         call inc(p1, p2, ep)
 20   continue

      stop
      end

