#!/usr/bin/perl
#
# $Id: histgram.pl,v 1.1 2001/10/17 17:40:02 nakano Exp $
# 
# histgram.pl
#
use Getopt::Std;

if (@ARGV < 2) {die "$0 min max\n"}
$min = $ARGV[0];
$max = $ARGV[1];
if ($min > $max) {die "$0 min max\n"}

@data = ();
while(<STDIN>){
	chomp;
	@line = split;
	push @data, $line[0];
}
$ndata = $#data + 1;

$step = ($max - $min) / int(sqrt($ndata));

$width = $max - $min;
for($i=0; $i * $step < $width; $i++){$freq[$i] = 0;}

while(@data){
	$datum = pop(@data);
	$i = int( ($datum - $min)/$step );
	$freq[$i]++;
}

for($i=0; $i * $step < $width; $i++){
	$f = $freq[$i] / ($step * $ndata);
	$label = $min + $step * $i;
	print "$label\t$f\n";
}

$label = $min + $step * $i;
print "#$label\tEND\n";

