      program sscatt
c
c     $Id: sscatt.f,v 1.3 2000/06/26 11:23:52 nakano Exp $
c     test program for scatt
c     print Collision Angle vs Collision Parameter
c     for Eini = 0.01eV--100eV
c     use 'gnuplot sscatt.gp' to view the graph.
c

c
c     particle1: Ar, Particle2: Cu
c
      real*8 bmpca1, bmpca2, bmpcb1, bmpcb2
      parameter (bmpca1 = 6960.9d0, bmpcb1 = 3.62654d0)
      parameter (bmpca2 = 13919.d0, bmpcb2 = 3.56137d0)

      integer ne0, nbc
      parameter (ne0 = 30, nbc = 30)

      real*8 e0max, e0min, bcmax
      parameter (e0min = 1.0d-3, e0max = 1.0d3, bcmax = 7.0d0)

      real*8 bmpca, bmpcb
      real*8 sangle

      real*8 e0, bc, le0dif, le0min
      integer ie0, ibc

      bmpca = dsqrt(bmpca1 * bmpca2)
      bmpcb = 0.5d0 * (bmpcb1 + bmpcb2)

      le0min = log(e0min)
      le0dif = log(e0max) - le0min

      call inispf2
      call setsp(bmpca, bmpcb)
      call hiab
      call setsca(ne0, nbc, e0max, e0min, bcmax)

      do 10 ie0 = -2, 2
         e0 = 10.0d0**ie0
         do 20 ibc = 0, 70
            bc = 0.1d0 * ibc
            call scat(e0, bc, sangle)
            write(6,1000) e0, bc, sangle
 20      continue
         write(6,*) ' '
 10   continue
 1000 format(1x, f6.2, f4.1, f12.6)
      stop
      end
