#!/usr/bin/perl
#
# $Id: bgraph.pl,v 1.9 2001/07/24 09:23:42 nakano Exp $
# visualize the result of pspread using gnuplot
#
# SELECT DEVICE
$dev = "ps"; # or "tek", if tek40xx is used
$eu    = 3000.0;
$estep = 30;

if (@ARGV < 3) {die "$0 infile element elemchar [ps]\n"};
$dfile = $ARGV[0];
$elem = $ARGV[1];
$spec = $ARGV[2];

open IF, "$dfile" or die "cannot open $dfile";
while(<IF>){
    if (/^ times to take snapshots \(s\)/) {last};
}

$i = 1;
while(<IF>){
    if (/== end of read data ==/) {last};
    chomp;
    @line = split(/: */);
    $snap[$i] = $line[1];
    $ts[$i] = $snap[$i] * 1.0;
    $i++;
}

$ip = 0;
$tp = 0;
while(<IF>){
    chomp;
    if (/^START:/) {
	$ip++;
        $tt[$ip] = 0;
#       print $it;
        $it = 0;
	next;
    }

    if (/^TRAPPED/) {
        chomp;
        ($dummy, $tt[$ip]) = split;
        $tp[$ip] = <IF>;
        chomp $tp[$ip];
        next;
    }
    $it++;
    unless (/^$snap[$i]/){print STDERR "DOESN'T MATCH: $ip $it\n";}
    $pp[$ip][$it] = $_;  
}
close IF;
$np = $ip;

#print "NP: $ip, TP: $tp\n";

print $mHead;
for($is=1;$is <= $#snap; $is++){
#    print "subplot(3,2,$is);\n";
    print "% for snapshot at $snap[$is]\n";
    $tus = $snap[$is] * 1e6;
    print $mSurf;

    $trapped = "";
    $flying  = "";
    for($ip=1;$ip<=$np;$ip++){
	if ($tt[$ip] == 0 || $tt[$ip] > $snap[$is]) {
	    @l = split / +/, $pp[$ip][$is];
	    $flying .= "$l[1] $l[2] $l[3];\n";
	} else {
	    @l = split / +/, $tp[$ip];
	    $trapped .= "$l[1] $l[2] $l[3];\n";
	}
    }
    print "clear F; F = [\n";
    print $flying;
    print "];\n";
    print $mPlotF;

    print "clear T; T = [\n";
    print $trapped;
    print "];\n";
    print $mPlotT;

#    print "title(\'T=$tus\\mus\', \'fontsize\', 30);\n";

    print "print -depsc2 bdiff$spec-$is.eps\n";
}

#}


# print -depsc L0.eps

BEGIN{
$mHead = << 'EOM';
% This is a MATLAB m-file
% automatically generated via bgraph.pl
clear;
LR = [0   4.5  4.5  6.5  6.5]';
LH = [0   0   -2   -2   -4.5]';
UR = [0   4    4    1    1  ]';
UH = [5   5    6.5  6.5  10.0]';
CC = [0.85 0.75  0.85  0.75  0.85]';
theta = [0:pi/20:2*pi];

LX = LR * cos(theta);
LY = LR * sin(theta);
LZ = LH * ones(1,41);
CM(:,:,1) = CC * ones(1,41);
CM(:,:,2) = CC * ones(1,41);
CM(:,:,3) = CC * ones(1,41);

UX = UR * cos(theta);
UY = UR * sin(theta);
UZ = UH * ones(1,41);

EOM

$mSurf = << 'EOM';
hold off;
surf(LX,LY,LZ,CM);
hold on;
surf(UX,UY,UZ,CM);
shading flat;

EOM

$mPlotF = << 'EOM';

FX = 100 * F(:,1);
FY = 100 * F(:,2);
FZ = 100 * F(:,3);

plot3(FX, FY, FZ, 'r.', 'MarkerSize', 2);

EOM

$mPlotT = << 'EOM';

TX = 100 * T(:,1);
TY = 100 * T(:,2);
TZ = 100 * T(:,3);

plot3(TX, TY, TZ, 'b.', 'MarkerSize', 2);

xlabel('X (cm)', 'fontsize', 20);
ylabel('Y (cm)', 'fontsize', 20);
zlabel('Z (cm)', 'fontsize', 20);

axis([-10 10 -10 10 -5 10]);
set(findobj('type', 'axes'), 'linewidth', 3);
set(findobj('type', 'axes'), 'fontsize', 15);
xtick = -10:5:10;
ytick = xtick;
ztick = -5:5:10;
set(gca, 'xtick', xtick);
set(gca, 'ytick', ytick);
set(gca, 'ztick', ztick);
set(gca, 'position', [0.15 0.13 0.7 0.7]);

EOM
}

