#!/usr/bin/perl
#
# $Id: com.pl,v 1.2 2001/11/08 12:07:49 nakano Exp $
#
use Statistics::Descriptive;

# consts
$ntry = 10000;
$nrep = 10;

$dfile = $ARGV[0];
#open IF, "$dfile" or die "cannot open $dfile";

#########################################################
# read snapshot times
#
while(<>){
    if (/^ times to take snapshots \(s\)/) {last};
}

$it = 0;
while(<>){
    if (/== end of read data ==/) {last};
    chomp;
    @line = split(/: /);
    $snap[$it] = $line[1];
    $stidx{$line[1]} = $it;
    $it++;
}
$nt = $it;

#########################################################
# parse data:
#
for($it = 0; $it < $nt; $it++){
    $pcom[$it][1] = Statistics::Descriptive::Full->new();
    $pcom[$it][2] = Statistics::Descriptive::Full->new();
    $pcom[$it][3] = Statistics::Descriptive::Full->new();
    $pdev[$it][1] = Statistics::Descriptive::Full->new();
    $pdev[$it][2] = Statistics::Descriptive::Full->new();
    $pdev[$it][3] = Statistics::Descriptive::Full->new();
}

for($irep = 0; $irep < $nrep; $irep++){
    for($it = 0; $it < $nt; $it++){
	$psum[$it][1] = Statistics::Descriptive::Full->new();
	$psum[$it][2] = Statistics::Descriptive::Full->new();
	$psum[$it][3] = Statistics::Descriptive::Full->new();
    }

    for($itry = 0; $itry < $ntry; $itry++){
	$ip = $irep * $ntry + $itry;
	while(<>){
	    chomp;
	    @line = split;

	    if (defined $stidx{$line[0]}) {
		$it = $stidx{$line[0]};
	    } else {
		next;
	    }

	    $px = $line[1] * 1.0; $psum[$it][1]->add_data($px);
	    $py = $line[2] * 1.0; $psum[$it][2]->add_data($py);
	    $pz = $line[3] * 1.0; $psum[$it][3]->add_data($pz);

#	    $vp[$it][$ip][1] = $line[4] * 1.0;
#	    $vp[$it][$ip][2] = $line[5] * 1.0;
#	    $vp[$it][$ip][3] = $line[6] * 1.0;

#	    print STDERR "$ip $it $snap[$it] x: $line[1] :: $psum[$it][1]\n";
#	    print STDERR "$ip $it $snap[$it] y: $line[2] :: $psum[$it][2]\n";
#	    print STDERR "$ip $it $snap[$it] z: $line[3] :: $psum[$it][3]\n";

	    if ($it == $nt - 1){last;}
	}
    }
    for($it = 0; $it < $nt; $it++){
	$pcom[$it][1]->add_data($psum[$it][1]->mean());
	$pcom[$it][2]->add_data($psum[$it][2]->mean());
	$pcom[$it][3]->add_data($psum[$it][3]->mean());
	$pdev[$it][1]->add_data($psum[$it][1]->standard_deviation());
	$pdev[$it][2]->add_data($psum[$it][2]->standard_deviation());
	$pdev[$it][3]->add_data($psum[$it][3]->standard_deviation());
    }
}

for($it = 0; $it < $nt; $it++){
    print "$snap[$it] ";
    for($axis = 1; $axis <= 3; $axis++){
#pdcom
	$count = $pcom[$it][$axis]->count();
	$mean  = $pcom[$it][$axis]->mean();
	$stdev = $pcom[$it][$axis]->standard_deviation();
	$err = $stdev / sqrt($count - 1);
	printf "\t%7.4f %7.4f", $mean, $err;

#pdev
	$count = $pdev[$it][$axis]->count();
	$mean  = $pdev[$it][$axis]->mean();
	$stdev = $pdev[$it][$axis]->standard_deviation();
	$err = $stdev / sqrt($count - 1);
	printf "\t%7.4f %7.4f", $mean, $err;
    }
    print "\n";
} 

