      program strap
c
c     test program for trap
c
      integer nmax, n
      parameter(nmax = 200)
      real*8 r(nmax+1), z(nmax+1)

      integer nsmax, ns
      parameter(nsmax = 100)
      real*8 rs(nsmax), zs(nsmax)

      real*8 path

      integer*4 seed
      integer trial
      integer i, j, k, idx
      real*8 p1(3), p2(3)
      real*8 q1(3), q2(3)
      real*8 pi, theta
      parameter (pi = 3.14159265357989d0)
      double precision genrand

      open(unit=5, status='old', file='input.dat')
      read(5, 2000) n, ns
 2000 format(2I5)

      call readin(seed, trial, n, r, z, ns, rs, zs, path)
      close(5)

      call sgenrand(seed)
      call settrap(n, r, z)

      do 6 i = 1, ns
      do 6 j = 1, trial
         theta = 2 * pi * genrand()
         p1(1) = rs(i) * cos(theta)
         p1(2) = rs(i) * sin(theta)
         p1(3) = zs(i)
         
         p2(1) = p1(1) + path * (genrand() - 0.5d0)
         p2(2) = p1(2) + path * (genrand() - 0.5d0)
         p2(3) = p1(3) + path * (genrand() - 0.5d0)
         
         call trap(p1, p2, idx)

         write(*,1005) (p1(k),k=1,3), (p2(k),k=1,3), idx
 1005    format(' (', 3F8.3, ')-(', 3F8.3, '): node: ', I3)
 6    continue

      stop
      end
c================================

      subroutine readin(seed, trial, n, r, z, ns, rs, zs, path)
c
c     readin data
c
      integer*4 seed
      integer trial, n, ns
      real*8 r(n+1), z(n+1)
      real*8 rs(ns), zs(ns)
      real*8 path

      integer i

      read(5,2010) seed
      read(5,2010) trial
 2010 format(i16)


      do 10 i = 1, n+1
         read (5,2000) r(i), z(i)
 10   continue

      do 30 i = 1, ns
         read (5, 2000) rs(i), zs(i)
 30   continue
 2000 format(2F13.6)

      read(5,2020) path
 2020 format(F13.6)

      write(*,1005) seed, trial
 1005 format(1x, 'rnd seed:', i12, 'trial:', i12)

      do 40 i =1, n
         write(*,1000) i, r(i), z(i), r(i+1), z(i+1)
 40   continue
 1000 format(1x, i3, '(', F8.2, ',', F8.2, ')-(',
     $                    F8.2, ',', F8.2, ')')

      do 50 i = 1, ns
         write(*,1010) i, rs(i), zs(i)
 50   continue
 1010 format(1x, 'source', i3, ': (',
     $       F8.2, ',', F8.2, ')')

      write(*,1020) path
 1020 format(1x, 'path length: ', f8.2)

      return
      end
