      program scollision
c
c     $Id: svrel.F,v 1.4 2001/10/22 21:44:20 nakano Exp $
c     test routine for collision.f
c     print nodes for spline func, then random trials
c
#include "hisput.h"
      real*8 unitam, unitch, unitbz, pi
      parameter (unitam = UNITAM)
      parameter (unitch = UNITCH)
      parameter (unitbz = UNITBZ)
      parameter (pi = PIDBL)

      real*8 tgas, pgasig, tgasig, ngas
      real*8 mgas, mpar, rmax
      integer ne, nw
      real*8 emax, emin, wmax, wmin
      real*8 ep, wp, vp, vg
      real*8 vr, vrr, vrx, vry, vrz
      real*8 ct, emrat2
      integer*4 irnd
      real*8 genrand

      integer ivp, nvp
      parameter (nvp = 4)
      real*8 vptest(nvp)
      data vptest /0.0d0, 300.0d0, 1000.0d0, 3000.0d0/ 

      integer it, nt
      parameter (nt = 100000)

      tgas = 400d0
      pgasig = 1.0d0
      tgasig = 293.0d0
      ngas = pgasig / (unitbz * tgasig)
C
C     Cu -> Ar
C
      mgas = 40d0 * unitam
      mpar = 63.5d0 * unitam
      rmax = 0.7d-9

      ne = 30
      nw = 30
      emax = 1.d3
      emin = 1.d-3
      wmax = 0.99d0
      wmin = 0.01d0

      emrat2 = 2 * unitch / mpar

      call inispf1
      call inispf2
      irnd = 1
      call sgenrand(irnd)

      call setcol(tgas, ngas, mgas, mpar, rmax,
     $     ne, nw, emax, emin, wmax, wmin)
      call setcdir(mpar, mgas, rmax)

      do 10 ivp = 1, nvp

         vp = vptest(ivp)
         ep = vp**2 / emrat2
         write(6,1010) vp, ep

         do 20 it = 1, nt
            wp = genrand()
            call colgas(ep, wp, vg)

            wp = genrand()
            call relv(ep, vg, wp, vr)
 
            if (vp .le. 0.0d0) then
               ct = 1.0d0 - 2 * genrand()
            else
               ct = (vp**2 + vr**2 - vg**2) / (2 * vp * vr)
            end if
            vrz = vr * ct
            vrr = vr * dsqrt(1.0d0 - ct**2)

            wp = 2 * pi * genrand()
            vrx = vrr * cos(wp)
            vry = vrr * sin(wp)

            write(6,1000) vrx, vry, vrz
 20      continue
         write(6,1020)
 10   continue
 1000 format(4f20.7)
 1010 format('# Vp = ', f10.5, 'm/s (', f10.5, 'eV)')
 1020 format('')

      stop
      end

