 set terminal postscript eps plus
 set output "v3k.eps"
set noclip points
set clip one
set noclip two
set border
set boxwidth
set dummy u,v
set format x "%g"
set format y "%g"
set format z "%g"
set nogrid
set nokey
set nolabel
set noarrow
set nologscale
set offsets 0, 0, 0, 0
set nopolar
set angles radians
set parametric
set view 71.5, 30, 1, 1
set samples 100, 100
set isosamples 10, 10
set surface
set nocontour
set clabel
set nohidden3d
set cntrparam order 4
set cntrparam linear
set cntrparam levels auto 5
set cntrparam points 5
set size 0.7,1
set data style points
set function style lines
set xzeroaxis
set yzeroaxis
set tics in
set ticslevel 0
set xtics -2000,2000,2000
set ytics -2000,2000,2000
set ztics -2000,2000,2000
set xlabel '\huge V_{\Large RX}(m/s)' -2,-1
set xrange [-5000 : 5000]
set ylabel '\huge V_{\Large RY}(m/s)' 2,-2
set yrange [-5000 : 5000]
set label 1 '\huge V_{\Large RZ}(m/s)' at -5000,-5000,7000 cente
set zrange [-5000 : 5000]
set autoscale r
set autoscale t
set noautoscale xy
set noautoscale z
set zero 1e-08
#set label "\rm\huge (a)" at -5,-5,10 center
set title '\huge Vp = 3000m/s' 0,-2
splot "svrel.dat" every :::3::3 with dots
