c     This file is a part of HISPUT, simulation program of
c     sputtering deposition.
c
c     Copyright (c) 1998 Takeo Nakano
c
c     This program is free software; you can redistribute it and/or
c     modify it under the terms of the GNU General Public License
c     as published by the Free Software Foundation; either version
c     2 of the License, or (at your option) any later version.
c
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.
c
c     You should have received a copy of the GNU General Public
c     License along with this program; if not, write to the Free
c     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
c     MA 02111-1307, USA
c
c     $Id: bisectf.f,v 1.1.1.1 2000/01/06 05:47:16 nakano Exp $
c

      subroutine bisctf(func, upper, lower, eps, root)
c
c     Find the solution in the range [lower, upper] satisfing the eq.
c       func(root)=0
c     by bisection method, with the precision eps.
c
      real*8 func, lower, upper, root, eps, y
      real*8 fl, fu, fr, ru, rl

      ru = upper
      rl = lower
      
      fu = func(ru)
      fl = func(rl)

c     when func(upper)*func(lower)>0, put error message & return
c
      if (fl * fu .gt. 0) then
        write(6,1000)
 1000   format(1x,'(bisect) -- function value of each boundary '/
     #            '            has same sign. return mean value')
        root = (ru + rl) / 2
        return
      end if

      y = fl

   10 continue
         root = (ru + rl)/2
         fr = func(root)
c         write(*,*) root, fr
         if (y * fr .gt. 0) then
            rl = root
         else
            ru = root
         end if
         if (dabs((ru-rl)/ru) .ge. eps) go to 10

c	returns ru if f(ru) > 0, or rl if f(rl)>0.
c
      if (fr .lt. 0.0d0) then
         if (root .eq. ru) then
            root = rl
         else
            root = ru
         end if
      end if

      return
      end
