c     This file is a part of HISPUT, simulation program of
c     sputtering deposition.
c
c     Copyright (c) 1998 Takeo Nakano
c
c     This program is free software; you can redistribute it and/or
c     modify it under the terms of the GNU General Public License
c     as published by the Free Software Foundation; either version
c     2 of the License, or (at your option) any later version.
c
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.
c
c     You should have received a copy of the GNU General Public
c     License along with this program; if not, write to the Free
c     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
c     MA 02111-1307, USA
c
c     $Id: maxwel.f,v 1.1 2001/10/22 21:52:35 nakano Exp $
c

      subroutine smaxwel(mgas, tgas)
c
c     setup routine for maxwel
c     inputs:
c       mgas .. mass of the gas (kg)
c       tgas .. temp. of the gas (K)
c     parameter:
c       unitbz .. Boltzmann's constant (J/K)
c
      real*8 mgas, tgas
      real*8 unitbz
      parameter (unitbz = 1.380658d-23)
      real*8 alphsq
      common /cmaxwl/ alphsq

      alphsq = sqrt(mgas / (unitbz * tgas))
      return
      end


      subroutine maxwel(vg)
c
c     give the randomly obtained atom velocity of gas
c     obeying Maxwell distribution function.
c
c     OUTPUT
c     vg(3) x,y,z coodinates of gas velocity (m/s)
c
      real*8 vg(3)
      real*8 alphsq
      common /cmaxwl/ alphsq

      real*8 genrand, nrnd
      external genrand

      do 10 i = 1, 3
         vg(i) = nrnd(genrand) / alphsq
 10   continue
      return
      end

