c     This file is a part of HISPUT, simulation program of
c     sputtering deposition.
c
c     Copyright (c) 1998 Takeo Nakano
c
c     This program is free software; you can redistribute it and/or
c     modify it under the terms of the GNU General Public License
c     as published by the Free Software Foundation; either version
c     2 of the License, or (at your option) any later version.
c
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.
c
c     You should have received a copy of the GNU General Public
c     License along with this program; if not, write to the Free
c     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
c     MA 02111-1307, USA
c
c     $Id: nrnd.f,v 1.1 2001/07/24 14:38:00 nakano Exp $
c

      double precision function nrnd(urnd)
c
c     generate normal random number using the uniform
c     random function urnd
c
c     REFERENCE: "RANSUU (UP ouyou suugaku sensho 12)"
c       Masanori Fushimi, Univ. of Tokyo press. 1989 pp.69
c
      real*8 urnd
      real*8 u1, u2, nrndsq
      real*8 c1, c2, c3

C     parameter (e = 2.71828182845904523536D0)
C     parameter (c1 = (8.0d0/e)**0.5d0)
C     parametar (c2 = 4.0d0 * e**0.25d0)
C     parameter (c3 = 4.0d0 * e**(-1.35d0))

      parameter (c1 = 1.715527769921413537D0)
      parameter (c2 = 5.136101666750965578D0) 
      parameter (c3 = 1.036961042583566028D0) 


 10   continue
         u1 = urnd()
         u2 = urnd()

         nrnd = c1 * (u2 - 0.5d0) / u1
         nrndsq = nrnd**2
         if (nrndsq .le. 5.d0 - c2 * u1) return
         if (nrndsq .ge. c3 / u1 + 1.4d0) go to 10
         if (nrndsq .le. -4 * log(u1)) return

      go to 10
      end

