/*
   This file is a part of HISPUT, simulation program of
   sputtering deposition
   Copyright (c) 1998 Takeo Nakano

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version
   2 of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public
   License along with this program; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA

   $Id: setfpucw.c,v 1.4 2001/01/04 21:47:26 nakano Exp $

   setfpu.c - fortran interface to wm-Linux-FPU-execptinos.
   <http://www.suburbia.net/~billm/floating-point/wmexcp.html>
   
   when this this routine is called from fortran source as:

   call setfpu

   then floating point exeption or NaN occurence will break the
   program execution.
*/

#include <fpu_control.h>

void setfpu_()
{
	fpu_control_t cw;

	cw = _FPU_DEFAULT & ~(_FPU_MASK_IM | _FPU_MASK_ZM | _FPU_MASK_OM);
	_FPU_SETCW(cw);
}

