c     This file is a part of HISPUT, simulation program of
c     sputtering deposition.
c
c     Copyright (c) 1998 Takeo Nakano
c
c     This program is free software; you can redistribute it and/or
c     modify it under the terms of the GNU General Public License
c     as published by the Free Software Foundation; either version
c     2 of the License, or (at your option) any later version.
c
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.
c
c     You should have received a copy of the GNU General Public
c     License along with this program; if not, write to the Free
c     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
c     MA 02111-1307, USA
c
c     $Id: axarea.F,v 1.1.1.1 2000/01/06 05:47:16 nakano Exp $
c
#include "hisput.h"

      subroutine axarea (r1, z1, r2, z2, s)
c
c     calculate the area of BEM node in axsisymmetric problem
c
c     == input ==
c       r1, z1 ... radial and azimutial coordinate of one node
c       r2, z2                                        other
c
c     == output ==
c       s ... node area
c
      real*8 r1, z1, r2, z2, s
      real*8 cott, sint, dr, dz, bz1, pi
      parameter (pi = PIDBL)

      real*8 dr2, dr2a1, dr2a2
      dr2(dr2a1, dr2a2) = dabs(dr2a1**2 - dr2a2**2)

      dz = dabs(z2 - z1)

      if (dz .eq. 0.d0) then
         s = pi * dr2(r1, r2)
      else if (r2 .eq. r1) then
         s = 2 * pi * r1 * dz
      else
         dr = dabs(r2 - r1)
         cott = dz / dr
         sint = 1.d0 / dsqrt(1.d0 + cott)

#ifdef DEBUG
         write(0,*) cott, sint
#endif

         bz1 = dmin1(r1, r2) * cott
         s = pi * ( dr2(r1, r2) + dz*(2*bz1+dz) ) * sint
      end if
      return
      end
