c     This file is a part of HISPUT, simulation program of
c     sputtering deposition.
c
c     Copyright (c) 1998 Takeo Nakano
c
c     This program is free software; you can redistribute it and/or
c     modify it under the terms of the GNU General Public License
c     as published by the Free Software Foundation; either version
c     2 of the License, or (at your option) any later version.
c
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.
c
c     You should have received a copy of the GNU General Public
c     License along with this program; if not, write to the Free
c     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
c     MA 02111-1307, USA
c
c     $Id: ellipt.f,v 1.1.1.1 2000/01/06 05:47:17 nakano Exp $
c
c     calculate complete elliptic function of 1st/2nd kind
c
c     DELLF(k) .. 1st kind
c     DELLS(k) .. 2nd kind
c
c     need to link libslatec.a
c
      double precision function dellf(k)
C                     2
C     K(K) = DRF(0,1-K ,1)
C
C            PI/2     2   2      -1/2
C          = INT  (1-K SIN (PHI) )   D PHI
C             0
C
C     Bulirsch form of ELLIPTIC INTEGRAL of 1st kind
C
      real*8 k

      real*8 drf
      integer ier
      real*8 zero, one
      parameter (zero = 0.0d0, one = 1.0d0)

      dellf = drf(zero, one - k**2, one, ier)

      if (ier .gt. 0) then
        write(*,*) '(dellf) -- ier nonzero'
      end if

      return
      end

      double precision function dells(k)
C                     2        2            2
C     E(K) = DRF(0,1-K ,1) - (K/3) DRD(0,1-K ,1)
C
C            PI/2     2   2      1/2
C          = INT  (1-K SIN (PHI) )  D PHI
C             0
C
C     Bulirsch form of ELLIPTIC INTEGRAL of 2nd kind
C
      real*8 k
      real*8 ksq, drf, drd
      integer ierf, ierd
      real*8 zero, one

      parameter (zero = 0.0d0, one = 1.0d0)

      ksq = k**2
      dells = drf(zero, one - ksq, one, ierf)
     $      - 1.0d0/3 * ksq * drd(zero, one - ksq, one, ierd)

      if ((ierf .gt. 0) .or. (ierd .gt. 0)) then
        write(*,*) '(dells) -- ier nonzero'
      end if

      return 
      end

