c     This file is a part of HISPUT, simulation program of
c     sputtering deposition.
c
c     Copyright (c) 1998 Takeo Nakano
c
c     This program is free software; you can redistribute it and/or
c     modify it under the terms of the GNU General Public License
c     as published by the Free Software Foundation; either version
c     2 of the License, or (at your option) any later version.
c
c     This program is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.
c
c     You should have received a copy of the GNU General Public
c     License along with this program; if not, write to the Free
c     Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
c     MA 02111-1307, USA
c
c     $Id: sp.f,v 1.1.1.1 2000/01/06 05:47:17 nakano Exp $
c
c     scattering potential function (Born-Mayer type)
c
c     contains:
c       subroutine setsctpot(bmpca, bmpcb)
c       real*8 function sctpot(r)
c

      double precision function sp(r)
c
c     Function which returns scattering potential in eV.
c     distance r is given in angstroms.
c
      real*8 r
      real*8 abm, bbm
      common /csp/ abm, bbm
      sp = abm * dexp(- r * bbm)
      return
      end


      subroutine setsp(bmpca, bmpcb)
c
c     prepare common blocks for sctpot
c
      real*8 bmpca, bmpcb
      real*8 abm, bbm
      common /csp/ abm, bbm
      abm = bmpca
      bbm = bmpcb
      return
      end

