#!/usr/bin/perl

$cond_dir = "../00common";
$scacol   = "$cond_dir/scacol-40.dat";
$bound    = "$cond_dir/bd-LB-10cm.dat";

$nt = 2;
@td = ("0.0", "400.0");
@tf = ("00K", "4hK");

$np = 11;
@pf = (                                "0m50", "0m70",
       "1m10", "1m15", "1m20", "1m35", "1m50", "1m70",
       "2m10", "2m15", "2m20");
@pd = (                          0.5, 0.7,
         1.0,  1.5,  2.0,  3.5,  5.0, 7.0,
        10.0, 15.0, 20.0);

$ne = 6;
@ef = ("B02", "L02", "B05", "L05", "B10", "L10");
@ed = ("$cond_dir/ia-BA-002.dat",
       "$cond_dir/ia-LA-002.dat",
       "$cond_dir/ia-BA-005.dat",
       "$cond_dir/ia-LA-005.dat",
       "$cond_dir/ia-BA-010.dat",
       "$cond_dir/ia-LA-010.dat");

$trial = 100000;

$nrep = 10;

for($ie=0; $ie<$ne; $ie++){
for($it=0; $it<$nt; $it++){
for($ip=0; $ip<$np; $ip++){
    $dir = "$ef[$ie]-$tf[$it]-$pf[$ip]";
    system "mkdir -p $dir";

    for ($irep=0; $irep < $nrep; $irep++){
	$infile = "$dir/$irep.in";
        $seed = 1000 * $ie + 100 * $it + 10 * $ip + $irep;

        open IF, "> $infile" or die "cannot open $infile\n";
        print  IF "$irep.dat\n";
        printf IF "%10d\n", $seed;
        printf IF "%10d\n", $trial;
        print  IF "F\n";
        close IF;

        system "cat $ed[$ie]  >> $infile";

        open IF, ">> $infile" or die "cannot open $infile";
        printf IF "%14.6f\n", $td[$it];
        printf IF "%14.6f\n", $pd[$ip];
        close IF;

        system "cat $scacol  >> $infile";
        system "cat $bound   >> $infile";
    }
}}}

