#!/usr/bin/perl

#@kT = (4000, 2000, 800, 400, 200, 80, 40, 20, 0);
@kT = (4000, 2000, 800);
@pg = (2, 10);
$nseq = 10;

for($ip = 0; $ip < @pg; $ip++){
    for($ik = 0; $ik < @kT; $ik++){
	$dir = sprintf "%02dPa-%04d", $pg[$ip], $kT[$ik];
	system "mkdir -p $dir";
	for (my $iseq = 0; $iseq < $nseq; $iseq++){
	    my $seed = 10000 * $ip + 100 * $ik + $iseq;
	    &printout($dir, $iseq, $seed, $pg[$ip], $kT[$ik]);
	}
    }
}

sub printout{
    my ($dir, $seq, $seed, $pgas, $tt) = @_;

    open OF, "> $dir/$seq.in" or die "cannot open $dir/$seq\n";

    printf OF "%-20s # output file name\n", "$seq.dat";
    printf OF "%10d           # random seed\n", $seed;

    print OF << 'EOF';
    100000           # trial number
F                    # to calculate density (T) or not (F)
Cu                   # Sputtered atom: element name
     63.546          #                 mass (atomic unit)
    13919.0          #    BM parameter A (eV)
      3.56137        #                 b (1/A)
Ar                   # Gas atom      : element name
     39.948          #                 mass (atomic unit)
   6960.9            #    BM parameter A (eV)
      3.62645        #                 b (1/A)
      3.497          # Binding (sublimation) energy of target (eV)
    300.0            # Injection energy of noble gas ions to target (eV)
    400.0            # Gas temperature (K)
EOF

    printf OF "%14.6f       # Gas Pressure  (ion gauge value) (Pa)\n", $pgas;

    print OF << 'EOF';
    296.0            #    Ion gauge's temperature assumption (K)
      0.6e-9         # Size of the collision target (m)
EOF

    printf OF "%14.6f       # Thermalization limit, unit in T of kT (K)\n", $tt;

    print OF << 'EOF';
        30           # Spline func. for sca : node # of energy axis
        30           #                      :           col.param axis
      1.0e+3         #                      : max energy (eV)
      1.0e-4         #                      : min energy (eV)
      6.5            #                      : max col.param (A)
        30           # Spline func. for col : node # of energy axis
        30           #                      :           probability axis
      1.0e+3         #                      : max energy (eV)
      1.0e-4         #                      : min energy (eV)
      0.99           #                      : max probability
      0.01           #                      : min probability
        58                     # number of bundary element
      0.0           0.0        # node positions (cm)
      0.5           0.0
      1.0           0.0
      1.4           0.0
      2.0           0.0
      2.5           0.0
      3.0           0.0
      3.6           0.0
      4.0           0.0
      4.5           0.0
      4.5          -1.0
      4.5          -2.0
      6.0          -2.0
      6.0          -4.5
      7.0          -4.5
      7.0          -2.0
      7.0           0.0
      7.0           2.0
      7.0           4.0
      7.0           6.0
      7.0           8.0
      7.0          10.0
      7.0          12.0
      6.0          12.0
      4.0          12.0
      2.0          12.0
      1.0          12.0
      1.0          10.0
      1.0           8.0
      1.0           6.5
      2.0           6.5
      2.5           6.5
      3.0           6.5
      3.25          6.5
      3.5           6.5
      3.75          6.5
      4.0           6.5
      4.0           6.25
      4.0           6.0
      4.0           5.75
      4.0           5.5
      4.0           5.25
      4.0           5.0
      3.75          5.0
      3.5           5.0
      3.25          5.0
      3.0           5.0
      2.75          5.0
      2.5           5.0
      2.25          5.0
      2.0           5.0
      1.75          5.0
      1.5           5.0
      1.25          5.0
      1.0           5.0
      0.75          5.0
      0.5           5.0
      0.25          5.0
      0.0           5.0
         0          # node class (0.. normal, 1.. erosion track)
         0
         0
         1
         1
         1
         1
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
         0
        23                     # number of nodes for erosion track
      1.4           0.000      # radial pos & depth of the track (cm)
      1.5           0.020      # (should cover the node with class 1) 
      1.6           0.036 
      1.7           0.060 
      1.8           0.094 
      1.9           0.120 
      2.0           0.152 
      2.1           0.190 
      2.2           0.216 
      2.3           0.216 
      2.4           0.196 
      2.5           0.172 
      2.6           0.146 
      2.7           0.110 
      2.8           0.088 
      2.9           0.072 
      3.0           0.048 
      3.1           0.034 
      3.2           0.030 
      3.3           0.022 
      3.4           0.012 
      3.5           0.006 
      3.6           0.000
EOF
    close OF;
}

