#!/usr/bin/perl
#
# $Id: summarize.pl,v 1.3 2001/05/02 13:37:35 nakano Exp $
#
use Statistics::Descriptive;

#
# defs
#
@tt = (0, 20, 40, 80, 200, 400, 800, 2000, 4000);
$nt = @tt;

$np = 2;
@pgas = (2, 10);

$nrep = 10;
$nnode = 58;

open OF, "> timesum.dat" or die "cannot open timesum.dat for writing\n";
for(my $ip = 0; $ip < $np; $ip++){
print OF "# $pgas[$ip] Pa\n";
for(my $it = 0; $it < $nt; $it++){

    my $dir = sprintf "%02dPa-%04d", $pgas[$ip], $tt[$it];

#
# position dependence
#
    for($in = 1; $in <= $nnode; $in++){
	$flux[$in] = Statistics::Descriptive::Sparse->new();
    }

    for(my $irep = 0; $irep < $nrep; $irep++){

	open DF, "$dir/$irep.dat" or die "cannot open $dir/$irep.dat";
	while(<DF>){
	    if (/^ ====RESULT/){last;}
	}

	while(<DF>){
	    chomp;
	    my @line = split;
	    $in = $line[0];
	    $nodeflux = $line[2] + $line[3];
	    $flux[$in]->add_data($nodeflux);
	}
	close DF;
    }
   
    open PF, "> $dir.dat" or
	die "cannot open posdep.dat for writing\n";
    print PF "#node\tflux\t(pm)\n";

    for($in = $nnode; $in > 0 ; $in--){
	$flux_m = $flux[$in]->mean();
	$flux_e = $flux[$in]->standard_deviation() / sqrt($flux[$in]->count());

	printf PF "%2d\t%7.3e\t%7.3e\n", $in, $flux_m, $flux_e;
    }
    close PF;

#
# time
#
    $ctime = Statistics::Descriptive::Sparse->new();
    for(my $irep = 0; $irep < $nrep; $irep++){
	open DF, "$dir/$irep.time" or die "cannot open $dir/$irep.time";
	while(<DF>){
	    if (/inputs/){next;}
	    my @l = split /user/;
	    $utime = $l[0];
	    $ctime->add_data($utime);
	}
	close DF;
    }
    $mean = $ctime->mean();
    $stdev = $ctime->standard_deviation();
    print OF "$tt[$it]\t$mean\t$stdev\n";
}}
close OF;

