#!/usr/bin/perl

$cond_dir = "../00common";
$element  = "$cond_dir/ia-CA-300.dat";
$scacol   = "$cond_dir/scacol-40.dat";

$nt = 2;
@td = ("0.0", "400.0");
@tf = ("00K", "4hK");

$np = 15;
@pf = ("0m10", "0m15", "0m20", "0m35", "0m50", "0m70",
       "1m10", "1m15", "1m20", "1m35", "1m50", "1m70",
       "2m10", "2m15", "2m20");
@pd = (  0.1,  0.15, 0.2,  0.35, 0.5, 0.7,
         1.0,  1.5,  2.0,  3.5,  5.0, 7.0,
        10.0, 15.0, 20.0);

$nr = 2;
@rf = ("07cm", "13cm");
@rd = ("$cond_dir/bd-FR-07cm.dat", "$cond_dir/bd-FR-13cm.dat");

$trial = 100000;

$nrep = 10;

for($ir=0; $ir<$nr; $ir++){
for($it=0; $it<$nt; $it++){
for($ip=0; $ip<$np; $ip++){
    $dir = "$rf[$ir]-$tf[$it]-$pf[$ip]";
    system "mkdir -p $dir";

    for ($irep=0; $irep < $nrep; $irep++){
	$infile = "$dir/$irep.in";
        $seed = 1000 * $ir + 100 * $it + 10 * $ip + $irep;

        open IF, "> $infile" or die "cannot open $infile\n";
        print  IF "$irep.dat\n";
        printf IF "%10d\n", $seed;
        printf IF "%10d\n", $trial;
        print  IF "F\n";
        close IF;

        system "cat $element  >> $infile";

        open IF, ">> $infile" or die "cannot open $infile";
        printf IF "%14.6f\n", $td[$it];
        printf IF "%14.6f\n", $pd[$ip];
        close IF;

        system "cat $scacol  >> $infile";
        system "cat $rd[$ir] >> $infile";
    }
}}}

