#!/usr/bin/perl
$cond_dir = "../00common";
$element  = "$cond_dir/ia-CA-300.dat";
$scacol   = "$cond_dir/scacol-0.dat";
$boundary = "$cond_dir/bd-CA-10cm.dat";

$tgas = 400.0;

$np = 4;
@pgas  = (2.0, 5.0, 10.0, 20.0);
@trial = (100000, 50000, 20000, 10000);
@fbase = ("020", "050", "100", "200");

$nrep = 5;

for ($ip = 0; $ip < $np; $ip++){
    for ($irep = 1; $irep <= $nrep; $irep++){
	$infile = "$fbase[$ip]-$irep.in";
        $seed = 100 * $ip + $irep;

        open IF, "> $infile" or die "cannot open $infile\n";
        print  IF "$fbase[$ip]-$irep.dat\n";
        printf IF "%10d\n", $seed;
        printf IF "%10d\n", $trial[$ip];
        print  IF "T\n";
        close IF;

        system "cat $element  >> $infile";

        open IF, ">> $infile" or die "cannot open $infile";
        printf IF "%14.6f\n", $tgas;
        printf IF "%14.6f\n", $pgas[$ip];
        close IF;

        system "cat $scacol   >> $infile";
        system "cat $boundary >> $infile";
    }
}

system "cp $cond_dir/region.dat .";

